local Version = 2.1
BuffSkinDB = {} 
local function SetupDB()
	
	BuffSkinDB = { 		
						Version = 2.1,
						Buff = {texture = "Interface\\AddOns\\BuffSkin\\textures\\texture1.tga",
									 Icon = {0,0,0,0},
									 Border = {0,0,0,0},
									 Gloss = {"none", 0,0,0,0,1}
									 }, 
						
						Debuff = {texture = "Interface\\AddOns\\BuffSkin\\textures\\texture1.tga",
									 Icon = {0,0,0,0},
									 Border = {0,0,0,0},
									 Gloss = {"none", 0,0,0,0,1}
									 },
						
						WepEnch = {texture = "Interface\\AddOns\\BuffSkin\\textures\\texture1.tga",
									 Icon = {0,0,0,0},
									 Border = {0,0,0,0},
									 Gloss = {"none",0,0,0,0,1}
									 },
				}
	
end

local function UpdateBorder(button, border, texture, coords) -- add mroe flags, coords, etc
local buff = _G[button]
	border:SetTexture(texture)
	border:SetTexCoord(0, 1, 0, 1)
	border:ClearAllPoints()
	border:SetPoint("TOPLEFT", buff ,"TOPLEFT", coords[1], coords[2])
	border:SetPoint("BOTTOMRIGHT", buff ,"BOTTOMRIGHT", coords[3], coords[4])
end

local function BuffSkin_OnEvent(self, event, addon) 
	if event == "ADDON_LOADED" then 
		if addon == "BuffSkin" then
			if (not BuffSkinDB) or not BuffSkinDB.Version or BuffSkinDB.Version < Version then 
				SetupDB()
			end 
			ConsolidatedBuffsIcon:SetTexture("Interface\\Buttons\\BuffConsolidation");
			ConsolidatedBuffsIcon:SetTexCoord(-0.05, 0.55, -0.1, 1.1);
			
			local buff = ConsolidatedBuffs:CreateTexture("bordermoo", "OVERLAY")
			buff = _G["bordermoo"]
			
			UpdateBorder("ConsolidatedBuffs", buff, BuffSkinDB.Buff.texture, BuffSkinDB.Buff.Border)
			
		end
	end
end

local function SkinAllBuffs(button, BSTable)
	local buff = _G[button]
	if not buff then return end 
	local border = _G[button.."Border"] or buff:CreateTexture(button.."Border", "OVERLAY")
	UpdateBorder(button, border, BuffSkinDB[BSTable].texture, BuffSkinDB[BSTable].Border)
	
	_G[button.."Count"]:SetDrawLayer("OVERLAY")
	
	local buffIcon = _G[button.."Icon"]
	buffIcon:SetTexCoord(0.1, 0.9, 0.1, 0.9)
	buffIcon:ClearAllPoints()
	buffIcon:SetPoint("TOPLEFT", buff ,BuffSkinDB[BSTable].Icon[1], BuffSkinDB[BSTable].Icon[2])
	buffIcon:SetPoint("BOTTOMRIGHT", buff ,"BOTTOMRIGHT", BuffSkinDB[BSTable].Icon[3], BuffSkinDB[BSTable].Icon[4])
	
	local Gtexture = _G[button.."Gloss"] or buff:CreateTexture(button.."Gloss","OVERLAY")
	if (BuffSkinDB[BSTable].Gloss[1] == "none") then 
		Gtexture:Hide()
	else
		Gtexture:SetTexture(BuffSkinDB[BSTable].Gloss[1])
		Gtexture:SetPoint("TOPLEFT", buff, "TOPLEFT", BuffSkinDB[BSTable].Gloss[2], BuffSkinDB[BSTable].Gloss[3])
		Gtexture:SetPoint("BOTTOMRIGHT", buff, "BOTTOMRIGHT", BuffSkinDB[BSTable].Gloss[4], BuffSkinDB[BSTable].Gloss[5])
		Gtexture:SetAlpha(BuffSkinDB[BSTable].Gloss[6])
		Gtexture:Show()
	end
end

BSBorderRefresh = function(self, event, unit, ...) 
	if (unit == "player") or (event == "PLAYER_ENTERING_WORLD") then
		for i = 1, 32 do 
			SkinAllBuffs("BuffButton"..i, "Buff")
			SkinAllBuffs("DebuffButton"..i,"Debuff")
		end		
		SkinAllBuffs("TempEnchant1", "WepEnch") 
		SkinAllBuffs("TempEnchant2", "WepEnch")
	end
end


local function Events(self, event, unit)
	if (event == "PLAYER_ENTERING_WORLD") or (event == "UNIT_AURA") then
		BSBorderRefresh(self, event, unit)
	elseif event == "ADDON_LOADED" then
		BuffSkin_OnEvent(self, event, unit) 
	end
end

local f = CreateFrame("Frame") 
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("UNIT_AURA")
f:RegisterEvent("ADDON_LOADED")				
f:SetScript("OnEvent", Events) 

SLASH_BuffSkin1 = "/Buffskin";
SLASH_BuffSkin2 = "/bs";
SlashCmdList["BuffSkin"] = function() LoadAddOn("BuffSkinConfig") InterfaceOptionsFrame_OpenToCategory(BuffSkinConfiger) end