﻿local CurrentType = "Buff"
local BuffExtraTextures = {}
local location = "Interface\\AddOns\\BuffSkin\\textures"
local f = CreateFrame("Frame",nil,UIParent) 
local testtexture = f:CreateTexture("moop","BORDER") 
local loaded = 0	
for i = 1,20 do	
	
	testtexture:SetTexture(location.."\\texture"..i..".tga")
	local visible = testtexture:GetTexture()
	if visible then
		BuffExtraTextures[i] = "\\texture"..i..".tga"
		loaded = loaded + 1
	end
end	
DEFAULT_CHAT_FRAME:AddMessage("BuffSkin: "..loaded.." Texture File(s) Loaded")

BuffSkinConfiger = CreateFrame("Frame")

local Title = BuffSkinConfiger:CreateFontString("BSTitle", "OVERLAY", "GameFontNormal")
Title:SetText("BuffSkin 配置:")
Title:SetWidth(150)
Title:SetHeight(20)
Title:SetPoint("TOP", BuffSkinConfiger, "TOP", 0, -20)


local Bordertext = BuffSkinConfiger:CreateFontString(nil, "OVERLAY", "GameFontNormal")
Bordertext:SetText("邊框大小:")
Bordertext:SetWidth(100)
Bordertext:SetHeight(20)
Bordertext:SetPoint("TOP", BuffSkinConfiger, "TOP", -140, -80)

local FrameLabel = BuffSkinConfiger:CreateFontString(nil, "OVERLAY", "GameFontNormal")
FrameLabel:SetText("框體類型:")
FrameLabel:SetWidth(100)
FrameLabel:SetHeight(20)
FrameLabel:SetPoint("TOP", BuffSkinConfiger, "TOP", -140, -130)

local TextureLabel = BuffSkinConfiger:CreateFontString(nil, "OVERLAY", "GameFontNormal")
TextureLabel:SetText("材質:")
TextureLabel:SetWidth(100)
TextureLabel:SetHeight(20)
TextureLabel:SetPoint("TOP", BuffSkinConfiger, "TOP", -140, -180)

local glosstexturelabel = BuffSkinConfiger:CreateFontString(nil, "OVERLAY", "GameFontNormal")
glosstexturelabel:SetText("Gloss 材質:")
glosstexturelabel:SetWidth(100)
glosstexturelabel:SetHeight(20)
glosstexturelabel:SetPoint("TOP", BuffSkinConfiger, "TOP", -140, -250)

local glossSizeLabel = BuffSkinConfiger:CreateFontString(nil, "OVERLAY", "GameFontNormal")
glossSizeLabel:SetText("Gloss 大小:")
glossSizeLabel:SetWidth(100)
glossSizeLabel:SetHeight(20)
glossSizeLabel:SetPoint("TOP", BuffSkinConfiger, "TOP", -140, -300)

local glossAlphaLabel = BuffSkinConfiger:CreateFontString(nil, "OVERLAY", "GameFontNormal")
glossAlphaLabel:SetText("Gloss 透明度:")
glossAlphaLabel:SetWidth(100)
glossAlphaLabel:SetHeight(20)
glossAlphaLabel:SetPoint("TOP", BuffSkinConfiger, "TOP", -140, -350)

local borderslide = CreateFrame("Slider", "BSborderslide", BuffSkinConfiger, "OptionsSliderTemplate")

				borderslide:SetMinMaxValues(-10,10)
				borderslide:SetValueStep(1)
				borderslide:SetValue(0)
				_G["BSborderslide".."Low"]:SetText("-10")
				_G["BSborderslide".."High"]:SetText("10")
				borderslide:SetScript("OnValueChanged", 
						function(self) local v = self:GetValue() 
											BuffSkinDB[CurrentType].Border[1] = -v
											BuffSkinDB[CurrentType].Border[2] = v
											BuffSkinDB[CurrentType].Border[3] = v
											BuffSkinDB[CurrentType].Border[4] = -v
											BSBorderRefresh(_,_,"player")
																end)
				borderslide:SetWidth(200)
				borderslide:SetHeight(20)
				borderslide:SetPoint("TOP", BuffSkinConfiger, "TOP", 40, -80)
				
local glossslide = CreateFrame("Slider", "BSglossslide", BuffSkinConfiger, "OptionsSliderTemplate")

				glossslide:SetMinMaxValues(-10,10)
				glossslide:SetValueStep(1)
				glossslide:SetValue(0)
				_G["BSglossslide".."Low"]:SetText("-10")
				_G["BSglossslide".."High"]:SetText("10")
				glossslide:SetScript("OnValueChanged", 
						function(self) local v = self:GetValue() 
											BuffSkinDB[CurrentType].Gloss[2] = -v
											BuffSkinDB[CurrentType].Gloss[3] = v
											BuffSkinDB[CurrentType].Gloss[4] = v
											BuffSkinDB[CurrentType].Gloss[5] = -v
											BSBorderRefresh(_,_,"player")
																end)
				glossslide:SetWidth(200)
				glossslide:SetHeight(20)
				glossslide:SetPoint("TOP", BuffSkinConfiger, "TOP", 40, -300)
				
local glossAlphaslide = CreateFrame("Slider", "BSglossAlphaslide", BuffSkinConfiger, "OptionsSliderTemplate")

				glossAlphaslide:SetMinMaxValues(0,1)
				glossAlphaslide:SetValueStep(0.01)
				glossAlphaslide:SetValue(0)
				_G["BSglossAlphaslide".."Low"]:SetText("0")
				_G["BSglossAlphaslide".."High"]:SetText("1")
				glossAlphaslide:SetScript("OnValueChanged", 
						function(self) local v = self:GetValue() 
											BuffSkinDB[CurrentType].Gloss[6] = v
											BSBorderRefresh(_,_,"player")
																end)
				glossAlphaslide:SetWidth(200)
				glossAlphaslide:SetHeight(20)
				glossAlphaslide:SetPoint("TOP", BuffSkinConfiger, "TOP", 40, -350)
				
				
local function UpdateConfig(name)
	borderslide:SetValue(BuffSkinDB[CurrentType].Border[2])
	glossslide:SetValue(BuffSkinDB[CurrentType].Gloss[3])
	glossAlphaslide:SetValue(BuffSkinDB[CurrentType].Gloss[6])
	BSBorderRefresh(_,_,"player")
end

BuffSkinConfiger.name = "BuffSkin"
InterfaceOptions_AddCategory(BuffSkinConfiger)

local BuffSelectorDD = CreateFrame("Frame", "BuffSelectorDD", BuffSkinConfiger, "UIDropDownMenuTemplate")
BuffSelectorDD:SetPoint("TOP", BuffSkinConfiger, "TOP", 40, -130)
UIDropDownMenu_SetWidth(BuffSelectorDD, 120)
UIDropDownMenu_SetButtonWidth(BuffSelectorDD, 80)



local function testfunc(i)
UIDropDownMenu_SetSelectedValue(BuffSelectorDD, i)
	BuffSkinDB[CurrentType].texture = location..BuffExtraTextures[i] 
	UpdateConfig(name) 	
end


function BuffSelectorDD_Initialize()
	level = level or 1
	for i = 1, 20 do
		if BuffExtraTextures[i] then 
			local info = UIDropDownMenu_CreateInfo()
			info.text = BuffExtraTextures[i]
			info.value = i
			info.checked = nil
			info.func = function() testfunc(i) end
				UIDropDownMenu_AddButton(info, level)
		end
	end
end
UIDropDownMenu_Initialize(BuffSelectorDD, BuffSelectorDD_Initialize)

UIDropDownMenu_SetSelectedValue(BuffSelectorDD, 1)



local BorderSelectorDD = CreateFrame("Frame", "BorderSelectorDD", BuffSkinConfiger, "UIDropDownMenuTemplate")
BorderSelectorDD:SetPoint("TOP", BuffSkinConfiger, "TOP", 40, -180)
UIDropDownMenu_SetWidth(BorderSelectorDD, 120)
UIDropDownMenu_SetButtonWidth(BorderSelectorDD, 40)




function BorderSelectorDD_Initialize()
level = level or 1
	local i = 0
	for name, v in pairs(BuffSkinDB) do
		if not ( name == "Version") then 
		i = i + 1
		local info = UIDropDownMenu_CreateInfo()
			info.text = name
			info.value = i
			info.checked = nil
			info.func = function()UIDropDownMenu_SetText(BorderSelectorDD, name) CurrentType = name UpdateConfig(name) end
			UIDropDownMenu_AddButton(info, level)
		end
	end
	
end
UIDropDownMenu_Initialize(BorderSelectorDD,BorderSelectorDD_Initialize)


UIDropDownMenu_SetSelectedValue(BorderSelectorDD, 3)



local GlossSelectorDD = CreateFrame("Frame", "GlossSelectorDD", BuffSkinConfiger, "UIDropDownMenuTemplate")
GlossSelectorDD:SetPoint("TOP", BuffSkinConfiger, "TOP", 40, -250)
UIDropDownMenu_SetWidth(GlossSelectorDD, 120)
UIDropDownMenu_SetButtonWidth(GlossSelectorDD, 40)


local function SetGloss(i)
	
	if i == "none" then
		BuffSkinDB[CurrentType].Gloss[1] = "none"
		UIDropDownMenu_SetText(GlossSelectorDD, "none")
	else
		BuffSkinDB[CurrentType].Gloss[1] = location..BuffExtraTextures[i] 
		UIDropDownMenu_SetText(GlossSelectorDD, BuffExtraTextures[i])
	end
	UpdateConfig(name) 	
end

function GlossSelectorDD_Initialize()
level = level or 1
	local i = 0
	
	local info = UIDropDownMenu_CreateInfo()
	info.text = "none"
	info.value = "none"
	info.checked = nil
	info.func = function() SetGloss("none") end
	UIDropDownMenu_AddButton(info, level)
	
	for i = 1, 20 do
		if BuffExtraTextures[i] then 
			local info = UIDropDownMenu_CreateInfo()
			info.text = BuffExtraTextures[i]
			info.value = i
			info.checked = nil
			info.func = function() SetGloss(i) end
				UIDropDownMenu_AddButton(info, level)
		end
	end
end
UIDropDownMenu_Initialize(GlossSelectorDD,GlossSelectorDD_Initialize)


UIDropDownMenu_SetSelectedValue(GlossSelectorDD, 3)